

#include <unistd.h>
#include <errno.h>
#include <sys/types.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <signal.h>
#include <time.h>

#include "common.h"
#include "message.h"
#include "buffer.h"
#include "transfer.h"

#include "merge.h"
#include "stats.h"

int Number = 0;

extern int NumRunningLinks;

extern STATUS_TABLE *status_table;
extern BUFFER_TABLE *buffer_table;
extern LINK_TABLE *link_table[NUMlinks];

extern int * StatsMem[NUMCOUNTERS];

extern int * MERGE_State;
extern int * MERGE_Action;
extern int * MERGE_Command;

extern void storage_init ();

extern int do_merge ();

BUFFER_HEADER* baseaddress;
extern void * shm_bufferarea[NUMlinks];

int firstLink;
int ActiveLinks[NUMlinks];
int isAlive[NUMlinks];
int dataLen[NUMlinks];
int bufferNumber[NUMlinks];
char * dataBuffer[NUMlinks];

extern int BufferSize;
char *output_buffer = NULL;

int NumSources = 0;

UINT64 lastTime = 0;      /*  time of last data item  */
UINT64 oldestTime = 0;    /*  from last data item  */
int oldestLink = 0;       /*  from last data item */
UINT wr4863 = 0;        /*  from last Info#5 */

int dataStart[NUMlinks];


int* Buffer32;


void merge_server ()  {

   int Signal = 0;
   int Waiting;
   int tryAgain;

   int ID;
   int i, j, l;
   int rc;
   int jj;

    sprintf (message_buffer,"Starting New Merge Server");
    report_message(MSG_INFORMATION);

    assignNetInt("MERGE_State", 0, 1, MERGE_IDLE);   /* state = stopped */
    assignNetInt("MERGE_Paused", 0, 1, TRUE);   /* state = paused */

    storage_init();

/*   initialise link buffer queues */

    for (ID=0; ID<status_table->num_links; ID++) {
      link_table[ID]->link_state = FREE;
      link_table[ID]->link_isAlive = IDLE;
      isAlive[ID] = IDLE;
    }

    lastTime = 0;
    oldestTime = 0;
    oldestLink = 0;


RESTART:

     NumSources = 0;
     for (ID = 0; ID < status_table->num_links; ID++) {
         if (link_table[ID]->link_state != LINK_GOING) continue;
         NumSources++;
     }

    sprintf (message_buffer,"Working with %d from %d data sources\n",NumSources,status_table->num_links);
    report_message(MSG_INFORMATION+0);

   tryAgain = FALSE;

TRYAGAIN:

   for (;;) {

      if (tryAgain == FALSE) Signal = wait_for_wakeup ();

 //     if (tryAgain == FALSE || Signal != SIGWAKEUP) {continue;}

      if (tryAgain == TRUE) {
        sprintf (message_buffer,"Trying again");
        report_message(MSG_DEBUG+0);
      } else {
        sprintf (message_buffer,"Received signal SIGWAKEUP");
        report_message(MSG_TRACE+0);
      }
      tryAgain = FALSE;

/*
    signal from Link task - a new data buffer is available on one of the links
    or trying again- a new data buffer might be available on one of the links
    But check for signal from Master

*/

            if (*MERGE_Command != DO_IDLE)    {sprintf (message_buffer,"Merge Signal %d  Command %d",*MERGE_Action,*MERGE_Command); report_message(MSG_WARNING);}

        switch (*MERGE_Command) {
            case DO_IDLE:
                Waiting = FALSE;
                goto WAITING;
                break;
            case MERGE_DOINGGO:
                *MERGE_State = MERGE_GOING;
                break;
            case MERGE_DOINGSTOP:
                *MERGE_State = MERGE_STOPPED;
                break;
            case MERGE_DOINGSETUP:
                break;
            case MERGE_DOINGRESET:
                break;
            case MERGE_ZEROTS:
                lastTime = 0ULL;
                oldestTime = 0ULL;
                sprintf (message_buffer,"Merge Time Stamp set to zero"); report_message(MSG_INFORMATION);
                break;
            default:
                sprintf (message_buffer,"Merge Signal %d",*MERGE_Action); report_message(MSG_WARNING);
        }
        *MERGE_Command = DO_IDLE;
        goto RESTART;

WAITING:

     if (Waiting == TRUE) {tryAgain = FALSE; goto TRYAGAIN;}

     NumRunningLinks = 0;
     *StatsMem[MNUMLINKS] = NumRunningLinks;

     for (ID = 0; ID < status_table->num_links; ID++) {
         if (link_table[ID]->link_state != LINK_GOING) continue;

     for (jj = 0; jj < status_table->num_links; jj++) {
       sprintf (message_buffer,"merge_server linkID %d; %d\n",jj, isAlive[jj]); report_message(MSG_DEBUG+0);
     }


sprintf (message_buffer,"checkpoint #0  %d %d ", ID,link_table[ID]->link_state ); report_message(MSG_DEBUG+0);

sprintf (message_buffer,"merge_server.c  active link %d %d %d %d\n",ID , status_table->num_links, link_table[ID]->link_state ,isAlive[ID]);
   report_message(MSG_DEBUG+0);

           if (isAlive[ID] == IS_ALIVE) {  /* already have a buffer for this link */

              i = bufferNumber[ID];

sprintf (message_buffer,"checkpoint #1"); report_message(MSG_DEBUG+0);


           } else {

                 i = obtain_data_buffer(ID);

sprintf (message_buffer,"checkpoint #2  %d",i); report_message(MSG_DEBUG+0);

                 if (i >= 0) {
                    j = ID*N_DATA_BUFFERS;

                    if (buffer_table->buffer_status[i+j] == PROCESSING) {
                       char * data_buffer;
                       DATA_HEADER* data_header;

                       baseaddress = (BUFFER_HEADER *) (char*) shm_bufferarea[ID];
                       data_buffer = (char *) ((char *)baseaddress + sizeof(BUFFER_HEADER)  + (i * status_table->data_buffer_size * 1024));
                       data_header = (DATA_HEADER *)data_buffer;
// header_dataLen is correct length of data minus the header
                       dataLen[ID] = data_header->header_dataLen  / sizeof (NewItDesc);
// skip the header
                       dataBuffer[ID] = &data_buffer[sizeof (HEADER)];
                       dataStart[ID] = 0;

                       isAlive[ID] = IS_ALIVE;

                       sprintf (message_buffer,"processing new data buffer %d %d %d %d 0x%08x %d", ID, i, j, dataLen[ID], dataBuffer[ID], dataStart[ID]);
                       report_message(MSG_TRACE);

/*
       Buffer32 = (int*)dataBuffer[ID];
       for (jj = 0; jj < 64;) {
           printf( " 0x%08x", Buffer32[dataStart[ID]+jj]);
          jj++;
          if ((jj/8)*8 == jj) { printf("\n");}
       }
        printf("\n");
*/

                        bufferNumber[ID] = i;
                     }   ;/*  end of  if (buffer_table->buffer_status[i+j] == PROCESSING  */

                 } else {

//	No data buffer at present 

                    isAlive[ID] = IS_WAITING;
                    Waiting = TRUE;

                    goto WAITING;

                 }  ;// end of if i>= 0)
           }    ;//   end of if (isAlive[ID] == IS_ALIVE

           NumRunningLinks++;
           *StatsMem[MNUMLINKS] = NumRunningLinks;

     }   ;//  end of for (ID = 0; ID < status_table->num_links; ID++

    if (NumRunningLinks == 0) goto WAITING;

     sprintf (message_buffer,"call do_merge %d", NumRunningLinks);
     report_message(MSG_TRACE+0);

     ID = do_merge ();  /* returns link ID which now has an empty data buffer */

     sprintf (message_buffer,"return do_merge %d %d", rc, ID);
     report_message(MSG_TRACE+0);

//     for (ID = 0; ID < status_table->num_links; ID++) {

        i = bufferNumber[ID];
        j = ID*N_DATA_BUFFERS;

        if (link_table[ID]->link_state == LINK_GOING) {
           if (buffer_table->buffer_status[i+j] == DONE) {

              sprintf (message_buffer,"done with data buffer %d  %d", ID, i);
              report_message(MSG_TRACE);

              release_data_buffer(ID,i);
              isAlive[ID] = IDLE;

           }
        }
//     }    /*  end of for (ID = 0; ID < status_table->num_links; ID++)  */

       goto WAITING;

   }      /*   end of for (;;)  */

}


