

#include <unistd.h>
#include <errno.h>
#include <sys/types.h>

#include <stdlib.h>
#include <stdio.h>
#include <string.h>

#include "common.h"
#include "message.h"
#include "buffer.h"
#include "transfer.h"

#include "merge.h"
#include "stats.h"

extern STATUS_TABLE *status_table;
extern BUFFER_TABLE *buffer_table;
extern LINK_TABLE *link_table[NUMlinks];

extern int * MERGE_RunOptions;

extern int * StatsMem[NUMCOUNTERS];

extern int do_storage (char *, int);

extern int Location;

extern  int BufferSize;
// I'm getting the buffer/block sizes wrong & TS can't handle it.
// Fudge it for now
#define MY_BUFFER_SIZE (BufferSize - 32)

extern UINT64 lastTime;      /*  time of last data item  */
extern UINT64 oldestTime;    /*  from last data item  */
extern int oldestLink;           /*  from last data item */

extern ItDesc_Ptr OutputBufferPtr;
extern int OutputBufferLen;
extern char * OutputBuffer;

int dataStart[NUMlinks];

extern int bufferNumber[NUMlinks];


// returns TRUE if caught up and can be merged or FALSE if not and complete buffer too old
int catchup (int id, char *dataBuffer, int dataLen) {

   int rc = 0;
   int i;
   NewItDesc_Ptr ps;

   sprintf (message_buffer, "catchup - link %d, dataLen %d, lastTime 0x%016llx", id, dataLen, lastTime);
   report_message(MSG_TRACE+0);

   dataStart[id] = 0;
   ps = (NewItDesc_Ptr)dataBuffer;
   for (i=0; i<dataLen; i++, ps++) {
      if (ps->Time >= lastTime) break;
   }

   if (i<dataLen) {
       sprintf (message_buffer, "caught up - index %d found 0x%016llx", i, ps->Time);
       report_message(MSG_DEBUG+0);
   } else {
       sprintf (message_buffer, "not caught up - last time in buffer 0x%016llx", (ps-1)->Time);
       report_message(MSG_DEBUG+0);
   }

// If we've looped thru' the whole buffer and not caught up we start at the start of the next buffer

   if (i == dataLen) {dataStart[id] = 0; rc = FALSE;} else {dataStart[id] = i; rc = TRUE;}

   sprintf (message_buffer, "catchup (link %d) returns %d", id, rc);
   report_message(MSG_DEBUG+0);

   return rc;
}

   int do_merge (int *ID, int howMany, int *ActiveLinks, char **dataBuffer, int *dataLen) {

       int id, rc, i, j, done;
       NewItDesc_Ptr ps, os;

       sprintf(message_buffer, "do_merge merging %d links  0x%016llx", howMany, lastTime);
       report_message(MSG_TRACE+0);

       for (i=1; i<=howMany; i++) {
          sprintf(message_buffer, "link %d datalen=%d", ActiveLinks[i], dataLen[i]);
          report_message(MSG_TRACE+0);
       }

       done=FALSE;

       while (done == FALSE) {
          os = NULL;
          oldestTime = 0;
          for (i=1; i<=howMany; i++) {
             id = ActiveLinks[i];
             ps = (NewItDesc_Ptr)dataBuffer[id];
             ps += dataStart[id];

             sprintf(message_buffer, "merge#1 %d 0x%x 0x%016llx 0x%016llx %d", id, ps, ps->Time, oldestTime, dataStart[id]);             
             report_message(MSG_DEBUG+0);

             if (ps->Time < oldestTime || oldestTime == 0) {
 
                sprintf(message_buffer, "merge#2 %d %d 0x%016llx 0x%016llx %d ",i, id, ps->Time, oldestTime, oldestLink);
                report_message(MSG_DEBUG+0);

                os = ps;
                oldestTime = os->Time;
                oldestLink = id;

             }
          }     ;//   for (i=1; i<=howMany; i++) - oldest TS now found

          sprintf(message_buffer, "merge#3 oldest %d 0x%8x 0x%016llx %d %d",oldestLink,os,oldestTime,dataStart[oldestLink],dataLen[oldestLink]);
          report_message(MSG_DEBUG+0);

          if (os != NULL) {   // be cautious - be sure an oldest has really been found

            dataStart[oldestLink]++;

            if (dataStart[oldestLink] >= dataLen[oldestLink]) {
               dataStart[oldestLink] = 0;
               done = TRUE;

               sprintf(message_buffer, "merge_server (merge done=TRUE) %d", oldestLink);
               report_message(MSG_DEBUG+0);
 
               i = bufferNumber[oldestLink];
               j = oldestLink*N_DATA_BUFFERS;

               buffer_table->buffer_status[i+j] = DONE;

               *ID = oldestLink;
            }

            if (os->Time < lastTime) {

              sprintf(message_buffer, "before previous time 0x%016llx < 0x%016llx", os->Time, lastTime);
              report_message(MSG_WARNING+0);

              lastTime = os->Time;
              (*StatsMem[MTIMEERR])++;   

            }  else {

// For now just output the data in the standard format

            sprintf(message_buffer, "merge_server (OP) %d 0x%016llx %lx %lx %d", oldestLink, os->Time, os->Data, os->Timestamp, OutputBufferLen);
            report_message(MSG_TRACE+0);

            lastTime = os->Time;
            (*StatsMem[MTIMEOK])++;   

            OutputBufferPtr->data = os->Data;
            OutputBufferPtr->timestamp = os->Timestamp;
            OutputBufferPtr++;

            OutputBufferLen += sizeof(ItDesc);

            if (OutputBufferLen >= (BufferSize - 32 - sizeof(ItDesc))) {

// No space for another item - the output buffer is full

               if ((*MERGE_RunOptions & 2) != 0) {rc = do_storage (OutputBuffer, OutputBufferLen);}
               OutputBufferPtr = (ItDesc_Ptr)OutputBuffer;
               OutputBufferLen = 0;

               (*StatsMem[MBUFFERS])++;           /* counter for number of merged data buffers */

            }

           }    ;//  end of os->Time < lastTime

         }    ;//  end of if (os)

      } // end of     while (done == FALSE)    loop - one of the input buffers is empty

      return rc;
   }




