/* This header file contains all sorts of odds and ends that might need to be sorted out and moved to a "proper" file */

/* We have a structure that describes each item. The type is
 * indicated by its info code or by a "pseudo" code for other data types
 */

// Existing data structure. Standard 32 bit data and timestamp
typedef struct ITEM_DESC {
	UINT32          data;
	UINT32          timestamp;
}	ItDesc, *ItDesc_Ptr;

// Not sure of the new structure yet... 2*32 bits of existing payload, 64 bits of "new" payload and 64 bit complete timestamp for now
typedef struct NEWITEM_DESC {
	UINT32          Data;
	UINT32          Timestamp;
	UINT32          Code; // Extended version of the information & ADC etc data types.
	UINT32          Info;
	UINT64          Time;
}	NewItDesc, *NewItDesc_Ptr;

typedef struct TF {
    UINT64   LastTime;
    UINT64   LastSync;
    UINT64   ExpectedSync;
    UINT64   HighBits;
    UINT64   AltHighBits;
    unsigned int SyncBits;
    int	Valid;
} TFrame, *TFrame_Ptr;

#define ADC_CODE		0x10
#define TRACE_CODE	        0x20
#define PAUSE_CODE		0x02
#define RESUME_CODE		0x03
#define SYNC_CODE		0x04
#define WR_CODE	        	0x05
#define FEE64_DISC_CODE		0x06
#define AIDA_SCALAR_CODE	0x08
#define R3B_EXT1_CODE           14
#define R3B_EXT2_CODE           15




